## libdrumstick 2.7.2

=== CMakeLists.txt ===
# MIDI C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.14)

project( Drumstick
    VERSION 2.7.2
    LANGUAGES CXX
    DESCRIPTION "MIDI C++ Libraries for Qt"
    HOMEPAGE_URL "https://sourceforge.net/p/drumstick/"
)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_admin)
include(SCMRevision)
include(CTest)
include(GNUInstallDirs)

set(RELEASE_DATE "October 1, 2022")
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# cmake bug https://gitlab.kitware.com/cmake/cmake/issues/18396 closed in cmake 3.14
if(APPLE AND ${CMAKE_VERSION} VERSION_LESS 3.14)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif()

if (WIN32 AND CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8") #/source-charset:utf-8 /execution-charset:utf-8
endif()

#[==[
compiler and linker extra checks:
if(UNIX AND NOT APPLE)
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -pedantic")
        set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed -Wl,-z,defs")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed -Wl,-z,defs")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed -Wl,--no-undefined -Wl,-z,defs")
    endif()
endif() 
]==]

add_definitions(-DVERSION=${PROJECT_VERSION})
if (DEFINED PROJECT_WC_REVISION)
    add_definitions(-DREVISION=${PROJECT_WC_REVISION})
endif()

if (UNIX)
    set(_DOCS_INIT ON)
else()
    set(_DOCS_INIT OFF)
endif()

set(_DBUS_INIT OFF)
if (UNIX AND NOT APPLE)
    set(_PULSE_INIT ON)
else ()
    set(_PULSE_INIT OFF)
endif ()

if (APPLE)
    set(_FRAMEWORKS_INIT ON)
else()
    set(_FRAMEWORKS_INIT OFF)
endif()

# ALSA Sequencer is only available on Linux
if (${CMAKE_SYSTEM} MATCHES "Linux")
    set(_BUILD_ALSA_INIT ON)
else()
    set(_BUILD_ALSA_INIT OFF)
endif()

option(BUILD_DOCS "Build Doxygen documentation and man pages" ${_DOCS_INIT})
option(BUILD_UTILS "Build Utilities and Examples" ON)
option(BUILD_FRAMEWORKS "Build macOS style frameworks" ${_FRAMEWORKS_INIT})
option(BUILD_ALSA "Build the libdrumstick-alsa library (Linux only)" ${_BUILD_ALSA_INIT})
option(BUILD_FILE "Build the libdrumstick-file library" ON)
option(BUILD_RT "Build the libdrumstick-rt library" ON)
option(BUILD_WIDGETS "Build the libdrumstick-widgets library" ON)
option(STATIC_DRUMSTICK "Build and link static libraries instead of shared" OFF)
option(USE_DBUS "Include DBus support (required for RealtimeKit)" ${_DBUS_INIT})
option(USE_PULSEAUDIO "Build Sonivox RT backend (if PulseAudio is available)" ${_PULSE_INIT})
option(USE_FLUIDSYNTH "Build FluidSynth RT backend (if available)" ON)
option(USE_NETWORK "Build Network RT backend (if QtNetwork is available)" ON)
option(USE_SONIVOX "Build Sonivox RT backend (if Sonivox is available)" ${_PULSE_INIT})
option(USE_QT "Choose which Qt major version (5 or 6) to prefer. By default uses whatever is found")

if (BUILD_WIDGETS AND NOT BUILD_RT)
    message(FATAL_ERROR "libdrumstick-widgets requires libdrumstick-rt")
endif()

if(STATIC_DRUMSTICK)
    set(BUILD_SHARED_LIBS OFF)
    add_definitions(-DDRUMSTICK_STATIC)
    message(STATUS "Building static libraries")
else()
    set(BUILD_SHARED_LIBS ON)
    if (BUILD_FRAMEWORKS)
        message(STATUS "Building macOS style frameworks")
    else()
        message(STATUS "Building unix dynamic libraries")
    endif()
endif()

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
    set(CMAKE_FRAMEWORK ${BUILD_FRAMEWORKS})
endif()

if (UNIX AND NOT APPLE)
    if ((USE_PULSEAUDIO AND NOT USE_SONIVOX) OR (USE_SONIVOX AND NOT USE_PULSEAUDIO))
        message(FATAL_ERROR "Wrong combination of USE_SONIVOX and USE_PULSEAUDIO options")
    endif()
endif()

if (USE_QT)
    if (NOT (USE_QT EQUAL 5 OR USE_QT EQUAL 6))
        message(FATAL_ERROR "Wrong Qt major version. Only 5 and 6 are valid options")
    endif()
endif()

if (USE_QT EQUAL 5)
    find_package(QT NAMES Qt5)
elseif (USE_QT EQUAL 6)
    find_package(QT NAMES Qt6)
else()
    find_package(QT NAMES Qt5 Qt6)
endif()

if (QT_VERSION VERSION_LESS 6.0.0)
    find_package(Qt5 5.9 COMPONENTS Core REQUIRED)
else()
    if (QT_VERSION VERSION_LESS 6.2.0)
       message (FATAL_ERROR "Qt6 >= 6.2 is required, or use Qt5 >= 5.9")
    endif()
    find_package(Qt6 6.2 COMPONENTS Core REQUIRED)
    if (BUILD_FILE)
        find_package(Qt6Core5Compat REQUIRED)
    endif()
endif()

message(STATUS "Found Qt version = ${QT_VERSION}")

if(BUILD_ALSA AND USE_DBUS)
    find_package(Qt${QT_VERSION_MAJOR}DBus REQUIRED)
    add_definitions(-DRTKIT_SUPPORT)
    message(STATUS "Found QtDBus version = ${Qt${QT_VERSION_MAJOR}DBus_VERSION}")
endif()

if(BUILD_RT AND USE_NETWORK)
    find_package(Qt${QT_VERSION_MAJOR}Network REQUIRED)
    if(Qt${QT_VERSION_MAJOR}Network_FOUND)
        message(STATUS "Found QtNetwork version = ${Qt${QT_VERSION_MAJOR}Network_VERSION}")
    else()
        message(FATAL_ERROR "QtNetwork library not available. Network RT backend can't be built.")
    endif()
endif()

find_package(PkgConfig REQUIRED)
if(PKG_CONFIG_FOUND)
	message(STATUS "Program pkg-config ${PKG_CONFIG_VERSION_STRING} found (${PKG_CONFIG_EXECUTABLE})")
else()
	message(FATAL_ERROR "Program pkg-config not found")
endif()

# ALSA Sequencer is only available on Linux
if (BUILD_ALSA AND (${CMAKE_SYSTEM} MATCHES "Linux"))
    pkg_check_modules(ALSA REQUIRED IMPORTED_TARGET alsa>=1.0.0)
    if(ALSA_FOUND)
        message(STATUS "Found ALSA version = ${ALSA_VERSION}")
    else()
        message(FATAL_ERROR "library libdrumstick-alsa requested, but ALSA Sequencer was not found")
    endif()
endif()

if(BUILD_RT AND PKG_CONFIG_FOUND AND UNIX AND NOT APPLE)
    if (USE_PULSEAUDIO)
        pkg_check_modules(PULSE QUIET IMPORTED_TARGET libpulse-simple)
        if(PULSE_FOUND)
            message(STATUS "Found PulseAudio version = ${PULSE_VERSION}")
        else()
            message(FATAL_ERROR "PulseAudio library not available. Sonivox RT backend can't be built.")
        endif()
    endif()
endif()

if (BUILD_RT AND PKG_CONFIG_FOUND)
    if (USE_FLUIDSYNTH)
        pkg_check_modules(FLUIDSYNTH QUIET IMPORTED_TARGET fluidsynth>=1.1.1)
        if(FLUIDSYNTH_FOUND)
            message(STATUS "Found FluidSynth version = ${FLUIDSYNTH_VERSION}")
        else()
            message(FATAL_ERROR "FluidSynth library not available. FluidSynth RT backend can't be built.")
        endif()
    endif()
endif()

if (BUILD_RT AND USE_SONIVOX)
    find_package(sonivox CONFIG QUIET)
    if(sonivox_FOUND)
        message(STATUS "Found Sonivox version = ${sonivox_VERSION}")
    else()
        message(FATAL_ERROR "Sonivox library not available. SonivoxEas Synth RT backend can't be built.")
    endif()
endif()

if (${CMAKE_SYSTEM} MATCHES "Darwin" AND QT_VERSION VERSION_LESS 6.0.0)
    find_package(Qt${QT_VERSION_MAJOR}Concurrent REQUIRED)
    if (Qt${QT_VERSION_MAJOR}Concurrent_FOUND)
        message(STATUS "Found Qt${QT_VERSION_MAJOR}Concurrent version = ${Qt${QT_VERSION_MAJOR}Concurrent_VERSION_STRING}")
    endif()
endif()

# CMAKE_SYSTEM_PROCESSOR is broken on Windows with MSVC
# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2022/08
if (MSVC)
    string(TOLOWER ${MSVC_CXX_ARCHITECTURE_ID} CMAKE_SYSTEM_PROCESSOR)
endif()

message (STATUS "${PROJECT_NAME} v${PROJECT_VERSION}
    Install prefix: ${CMAKE_INSTALL_PREFIX}
    Build configuration: ${CMAKE_BUILD_TYPE}
    System: ${CMAKE_SYSTEM_NAME}
    Processor: ${CMAKE_SYSTEM_PROCESSOR}
    Qt Version: ${QT_VERSION}
    D-Bus support: ${USE_DBUS}
    Network support: ${USE_NETWORK}
    PulseAudio support: ${USE_PULSEAUDIO}
    FluidSynth support: ${USE_FLUIDSYNTH}
    Sonivox support: ${USE_SONIVOX}
    Building libdrumstick-alsa: ${BUILD_ALSA}
    Building libdrumstick-file: ${BUILD_FILE}
    Building libdrumstick-rt: ${BUILD_RT}
    Building libdrumstick-widgets: ${BUILD_WIDGETS}
    Building tests: ${BUILD_TESTING}
    Building docs: ${BUILD_DOCS}
    Building utils: ${BUILD_UTILS}
    Building frameworks: ${BUILD_FRAMEWORKS}"
)

add_subdirectory(library)
if (BUILD_UTILS)
    add_subdirectory(utils)
endif()
add_subdirectory(icons)

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

# translations
add_custom_target( update-translations COMMENT "Updating translations" )

if (BUILD_WIDGETS)
    add_dependencies( update-translations update-widget-translations )
endif()

if (BUILD_UTILS)
    if (BUILD_RT AND BUILD_WIDGETS)
        add_dependencies( update-translations update-vpiano-translations )
    endif()
    if(BUILD_ALSA AND ALSA_FOUND)
        add_dependencies( update-translations update-drumgrid-translations )
        if(BUILD_FILE)
            add_dependencies( update-translations update-guiplayer-translations )
        endif()
    endif()
endif()

# pkg-config support
if ( IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}" )
  set ( pkgconfig_libdir "${CMAKE_INSTALL_LIBDIR}" )
else ()
  set ( pkgconfig_libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}" )
endif ()
if ( IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}" )
  set ( pkgconfig_includedir "${CMAKE_INSTALL_INCLUDEDIR}" )
else ()
  set ( pkgconfig_includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}" )
endif ()

if(UNIX AND NOT APPLE)
    if (BUILD_DOCS)
        find_package(Doxygen REQUIRED dot)
        if(DOXYGEN_FOUND)
            string(REPLACE ";" " " DOXYGEN_INCLUDE_DIRS "${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}")
            configure_file("${CMAKE_SOURCE_DIR}/Doxyfile.in"
                "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" IMMEDIATE @ONLY)
            add_custom_target(doxygen
                ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
        endif()
        add_subdirectory(doc)
    endif()
    configure_file(drumstick.spec.in drumstick.spec IMMEDIATE @ONLY)
    if(ALSA_FOUND AND PKG_CONFIG_FOUND)
        configure_file(drumstick-alsa.pc.in drumstick-alsa.pc IMMEDIATE @ONLY)
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/drumstick-alsa.pc
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
    endif()
    # XML mime types
    set( SHARED_MIME_INFO_MINIMUM_VERSION "0.30" )
    set( XDG_MIME_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/mime/packages" )
    find_package( SharedMimeInfo )
    if( SHARED_MIME_INFO_FOUND )
        install( FILES drumstick.xml DESTINATION ${XDG_MIME_INSTALL_DIR} )
        update_xdg_mimetypes( ${XDG_MIME_INSTALL_DIR} )
    endif()
endif()

if(PKG_CONFIG_FOUND)
    configure_file(drumstick-file.pc.in drumstick-file.pc IMMEDIATE @ONLY)
    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-file.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
    configure_file(drumstick-rt.pc.in drumstick-rt.pc IMMEDIATE @ONLY)
    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-rt.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
    configure_file(drumstick-widgets.pc.in drumstick-widgets.pc IMMEDIATE @ONLY)
    install(FILES

=== doc/CMakeLists.txt ===
# MIDI Sequencer C++ Library 
# Copyright (C) 2008-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

find_program(XSLTPROC_EXECUTABLE xsltproc)
if(XSLTPROC_EXECUTABLE)
    message(STATUS "XSLTPROC Found: ${XSLTPROC_EXECUTABLE}")
    if (NOT RELEASE_DATE)
        execute_process (
            COMMAND bash -c "LANG=C;date +'%B %d, %Y'"
            OUTPUT_VARIABLE RELEASE_DATE
            OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    endif()
    configure_file(drumstick-devel.doc.txt.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-devel.doc.txt IMMEDIATE @ONLY)
    configure_file(drumstick-drumgrid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumpmid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumpsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumprmi.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumprmi.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumpwrk.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml IMMEDIATE @ONLY)
    configure_file(drumstick-metronome.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml IMMEDIATE @ONLY)
    configure_file(drumstick-playsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml IMMEDIATE @ONLY)
    configure_file(drumstick-guiplayer.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml IMMEDIATE @ONLY)
    configure_file(drumstick-sysinfo.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml IMMEDIATE @ONLY)
    configure_file(drumstick-vpiano.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml IMMEDIATE @ONLY)
    include(CreateManpages)
    create_manpages ( 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumprmi.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml 
    )
else()
    message(STATUS "Warning: XSLTPROC NOT Found. Man pages won't be installed")
endif()

=== icons/CMakeLists.txt ===
# MIDI C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

install(FILES drumstick_16.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps"
    RENAME drumstick.png)

install(FILES drumstick_32.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps"
    RENAME drumstick.png)

install(FILES drumstick_48.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps"
    RENAME drumstick.png)

install(FILES drumstick_64.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps"
    RENAME drumstick.png)

install(FILES drumstick.svgz
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps")

=== utils/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

if (BUILD_FILE)
    add_subdirectory(dumpsmf)
    add_subdirectory(dumprmi)
    add_subdirectory(dumpwrk)
endif()

if(BUILD_ALSA AND ALSA_FOUND)
    add_subdirectory(dumpmid)
    add_subdirectory(sysinfo)
    add_subdirectory(metronome)
    add_subdirectory(drumgrid)
    if(BUILD_FILE)
        add_subdirectory(playsmf)
        add_subdirectory(guiplayer)
    endif()
endif()

if (BUILD_RT AND BUILD_WIDGETS)
    add_subdirectory(vpiano)
endif()

=== library/rt-backends/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(DRUMSTICK_PLUGINS_DIR "drumstick2")

if(FALSE)
    add_subdirectory(dummy-in)
    add_subdirectory(dummy-out)
endif()

if(BUILD_ALSA AND ALSA_FOUND)
    add_subdirectory(alsa-in)
    add_subdirectory(alsa-out)
endif()

if (PULSE_FOUND AND sonivox_FOUND)
    add_subdirectory(eassynth)
endif()

if(Qt${QT_VERSION_MAJOR}Network_FOUND)
    add_subdirectory(net-in)
    add_subdirectory(net-out)
endif()

if(UNIX AND NOT APPLE)
    add_subdirectory(oss-in)
    add_subdirectory(oss-out)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    add_subdirectory(mac-in)
    add_subdirectory(mac-out)
    add_subdirectory(macsynth)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    add_subdirectory(win-in)
    add_subdirectory(win-out)
endif()

if(FLUIDSYNTH_FOUND)
    add_subdirectory(fluidsynth)
endif()

=== library/widgets/CMakeLists.txt ===
# Drumstick Widgets C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt${QT_VERSION_MAJOR}Widgets REQUIRED)
find_package(Qt${QT_VERSION_MAJOR}Network REQUIRED)
find_package(Qt${QT_VERSION_MAJOR}LinguistTools REQUIRED)

set(drumstick-widgets_HEADERS
    ../include/drumstick/pianokeybd.h
    ../include/drumstick/pianopalette.h
    ../include/drumstick/settingsfactory.h
    ../include/drumstick/configurationdialogs.h
)

set(drumstick-widgets_OBJ_SRCS
    ../include/drumstick/pianokeybd.h
    ../include/drumstick/pianopalette.h
    ../include/drumstick/rtmidiinput.h
    ../include/drumstick/rtmidioutput.h
    pianoscene.h
    fluidsettingsdialog.h
    networksettingsdialog.h
    macsynthsettingsdialog.h
    sonivoxsettingsdialog.h
)

if(BUILD_FRAMEWORKS)
    set_source_files_properties(${drumstick-widgets_HEADERS}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/drumstick
    )
endif()

set(drumstick-widgets_SRCS
    configurationdialogs.cpp
    fluidsettingsdialog.cpp
    fluidsettingsdialog.h
    keylabel.cpp
    keylabel.h
    macsynthsettingsdialog.cpp
    macsynthsettingsdialog.h
    networksettingsdialog.cpp
    networksettingsdialog.h
    pianokey.cpp
    pianokey.h
    pianokeybd.cpp
    pianopalette.cpp
    pianoscene.cpp
    pianoscene.h
    settingsfactory.cpp
    sonivoxsettingsdialog.cpp
    sonivoxsettingsdialog.h
)

set(drumstick-widgets_FORMS
    fluidsettingsdialog.ui
    macsynthsettingsdialog.ui
    networksettingsdialog.ui
    sonivoxsettingsdialog.ui
)

if (WIN32)
    set(TARGET_DESCRIPTION ${Drumstick_DESCRIPTION})
    set(TARGET_NAME drumstick-widgets)
    set(TARGET_ORIGINAL_FILENAME libdrumstick-widgets.dll)
    configure_file(${Drumstick_SOURCE_DIR}/versioninfo.rc.in versioninfo.rc @ONLY)
    list(APPEND drumstick-widgets_SRCS versioninfo.rc)
endif()

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_ui(drumstick-widgets_UI_SRCS ${drumstick-widgets_FORMS})
    qt5_wrap_cpp(drumstick-widgets_MOC_SRCS ${drumstick-widgets_OBJ_SRCS})
    qt5_add_resources(drumstick-widgets_RESOURCES pianokeybd.qrc)
else()
    qt_wrap_ui(drumstick-widgets_UI_SRCS ${drumstick-widgets_FORMS})
    qt_wrap_cpp(drumstick-widgets_MOC_SRCS ${drumstick-widgets_OBJ_SRCS})
    qt_add_resources(drumstick-widgets_RESOURCES pianokeybd.qrc)
endif()

add_library(drumstick-widgets
    ${drumstick-widgets_UI_SRCS}
    ${drumstick-widgets_MOC_SRCS}
    ${drumstick-widgets_SRCS}
    ${drumstick-widgets_RESOURCES}
    ${drumstick-widgets_HEADERS}
)

add_library(Drumstick::Widgets ALIAS drumstick-widgets)

target_include_directories(drumstick-widgets PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(drumstick-widgets PRIVATE
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Network
    Drumstick::RT
)

set(TS_FILES
    translations/drumstick-widgets_cs.ts
    translations/drumstick-widgets_de.ts
    translations/drumstick-widgets_en.ts
    translations/drumstick-widgets_es.ts
    translations/drumstick-widgets_fr.ts
    translations/drumstick-widgets_gl.ts
    translations/drumstick-widgets_it.ts
    translations/drumstick-widgets_nl.ts
    translations/drumstick-widgets_ru.ts
    translations/drumstick-widgets_sr.ts
    translations/drumstick-widgets_sv.ts
    translations/drumstick-widgets_tr.ts
    translations/drumstick-widgets_zh_CN.ts
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_add_translation(QM_FILES ${TS_FILES})
else()
    qt_add_translation(QM_FILES ${TS_FILES})
endif()

add_custom_target( update-widget-translations
    COMMAND Qt${QT_VERSION_MAJOR}::lupdate ${CMAKE_CURRENT_SOURCE_DIR}
        -I ${PROJECT_SOURCE_DIR}/library/include
        -I ${CMAKE_CURRENT_SOURCE_DIR}
        -I ${CMAKE_CURRENT_BINARY_DIR}
        -ts ${TS_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Updating widget translations"
)

add_custom_target( drumstick-widgets-translations ALL DEPENDS ${QM_FILES} )

if (UNIX)
    install( FILES ${QM_FILES}
             DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/drumstick )
endif ()

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-widgets PROPERTIES
        STATIC_LIB "libdrumstick-widgets")
else() # STATIC_DRUMSTICK
    set_target_properties(drumstick-widgets PROPERTIES
        VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        EXPORT_NAME Widgets
      # macOS:
        MACOSX_RPATH TRUE
    )
    if (BUILD_FRAMEWORKS)
        set_target_properties(drumstick-widgets PROPERTIES
            FRAMEWORK ${BUILD_FRAMEWORKS}
            FRAMEWORK_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
            MACOSX_FRAMEWORK_IDENTIFIER "net.sourceforge.drumstick-widgets"
            MACOSX_FRAMEWORK_INFO_PLIST "${CMAKE_SOURCE_DIR}/cmake_admin/CustomFrameworkInfo.plist.in"
        )
    endif()
endif() # STATIC_DRUMSTICK

install(TARGETS drumstick-widgets
    EXPORT drumstick-widgets-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${drumstick-widgets_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)

install(EXPORT drumstick-widgets-targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
    NAMESPACE Drumstick::
)

export(EXPORT drumstick-widgets-targets
    NAMESPACE Drumstick::
    FILE ${CMAKE_BINARY_DIR}/drumstick-widgets-targets.cmake
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(${CMAKE_BINARY_DIR}/drumstick-widgets-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_file( drumstick-widgets-config.cmake
  ${CMAKE_BINARY_DIR}/drumstick-widgets-config.cmake
  @ONLY
)

install(FILES
    ${CMAKE_BINARY_DIR}/drumstick-widgets-config-version.cmake
    ${CMAKE_BINARY_DIR}/drumstick-widgets-config.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
)

=== tests/alsaTest1/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

add_executable (alsaTest1 alsatest1.cpp)

target_link_libraries (alsaTest1 PRIVATE
    Drumstick::ALSA
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Test
)

add_test (alsaTest1 ${PROJECT_BINARY_DIR}/bin/alsaTest1)

=== tests/alsaTest2/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

add_executable (alsaTest2 alsatest2.cpp)

target_link_libraries (alsaTest2 PRIVATE
    Drumstick::ALSA
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Test
)

add_test (alsaTest2 ${PROJECT_BINARY_DIR}/bin/alsaTest2)

=== tests/widgetsTest/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

find_package(Qt${QT_VERSION_MAJOR}Widgets REQUIRED)

set ( SOURCES widgetstest.cpp )

add_executable ( widgetsTest ${SOURCES} )

target_include_directories ( widgetsTest PUBLIC
    ${CMAKE_SOURCE_DIR}/library/include )

target_link_libraries (widgetsTest PRIVATE
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Test
    Drumstick::Widgets )

add_test (widgetsTest ${PROJECT_BINARY_DIR}/bin/widgetsTest)

=== utils/drumgrid/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Gui Widgets LinguistTools REQUIRED)

set(drumgrid_forms_SRCS
    drumgridabout.ui
    drumgrid.ui
)

set(drumgrid_SRCS
    drumgridabout.cpp
    drumgridabout.h
    drumgrid.cpp
    drumgrid.h
    drumgrid.qrc
    drumgridmodel.cpp
    drumgridmodel.h
    drumgridmain.cpp
)

set(drumgrid_qtobject_SRCS
    drumgridabout.h
    drumgridmodel.h
    drumgrid.h
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_ui(drumgrid_ui_SRCS ${drumgrid_forms_SRCS})
    qt5_wrap_cpp(drumgrid_moc_SRCS ${drumgrid_qtobject_SRCS})
else()
    qt_wrap_ui(drumgrid_ui_SRCS ${drumgrid_forms_SRCS})
    qt_wrap_cpp(drumgrid_moc_SRCS ${drumgrid_qtobject_SRCS})
endif()

add_executable(drumstick-drumgrid
    ${drumgrid_ui_SRCS}
    ${drumgrid_moc_SRCS}
    ${drumgrid_SRCS}
)

target_link_libraries(drumstick-drumgrid PRIVATE
    Drumstick::ALSA
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Widgets
)

set(TS_FILES
    drumstick-drumgrid_en.ts
    drumstick-drumgrid_es.ts
    drumstick-drumgrid_it.ts
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_add_translation(QM_FILES ${TS_FILES})
else()
    qt_add_translation(QM_FILES ${TS_FILES})
endif()

add_custom_target( update-drumgrid-translations
    COMMAND Qt${QT_VERSION_MAJOR}::lupdate ${CMAKE_CURRENT_SOURCE_DIR} -ts ${TS_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Updating drumgrid translations"
)

add_custom_target( drumstick-drumgrid-translations ALL DEPENDS ${QM_FILES} )

if (UNIX AND NOT APPLE)
    install( FILES ${QM_FILES}
             DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/drumstick )
endif ()

install(TARGETS drumstick-drumgrid
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(FILES drumstick-drumgrid.desktop
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications"
        RENAME net.sourceforge.drumstick-drumgrid.desktop)

install(FILES drumstick-drumgrid.metainfo.xml
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
        RENAME net.sourceforge.drumstick-drumgrid.metainfo.xml)

=== utils/dumpmid/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(dumpmid_SRCS
    dumpmid.cpp
    dumpmid.h
)

set(dumpmid_qtobject_SRCS
    dumpmid.h
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_cpp(dumpmid_moc_SRCS ${dumpmid_qtobject_SRCS})
else()
    qt_wrap_cpp(dumpmid_moc_SRCS ${dumpmid_qtobject_SRCS})
endif()

add_executable(drumstick-dumpmid
    ${dumpmid_moc_SRCS}
    ${dumpmid_SRCS}
)

target_link_libraries(drumstick-dumpmid PRIVATE
    Drumstick::ALSA
    Qt${QT_VERSION_MAJOR}::Core
)

install(TARGETS drumstick-dumpmid
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== utils/guiplayer/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Gui Widgets LinguistTools REQUIRED)

set(guiplayer_forms_SRCS
    guiplayer.ui
    playerabout.ui
)

set(guiplayer_SRCS
    guiplayer.cpp
    guiplayer.h
    iconutils.cpp
    iconutils.h
    player.cpp
    player.h
    playerabout.cpp
    playerabout.h
    playermain.cpp
    song.cpp
    song.h
)

set(guiplayer_qtobject_SRCS
    player.h
    playerabout.h
    guiplayer.h
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_ui(guiplayer_ui_SRCS ${guiplayer_forms_SRCS})
    qt5_wrap_cpp(guiplayer_moc_SRCS ${guiplayer_qtobject_SRCS})
    qt5_add_resources(guiplayer_resources guiplayer.qrc)
else()
    qt_wrap_ui(guiplayer_ui_SRCS ${guiplayer_forms_SRCS})
    qt_wrap_cpp(guiplayer_moc_SRCS ${guiplayer_qtobject_SRCS})
    qt_add_resources(guiplayer_resources guiplayer.qrc)
endif()

add_executable(drumstick-guiplayer
    ${guiplayer_resources}
    ${guiplayer_ui_SRCS}
    ${guiplayer_moc_SRCS}
    ${guiplayer_SRCS}
)

target_link_libraries(drumstick-guiplayer PRIVATE
    Drumstick::File
    Drumstick::ALSA
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Widgets
)

if(QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
    target_link_libraries(drumstick-guiplayer PRIVATE Qt6::Core5Compat)
endif()

set(TS_FILES
    drumstick-guiplayer_cs.ts
    drumstick-guiplayer_es.ts
    drumstick-guiplayer_it.ts
    drumstick-guiplayer_ru.ts
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_add_translation(QM_FILES ${TS_FILES})
else()
    qt_add_translation(QM_FILES ${TS_FILES})
endif()

add_custom_target( update-guiplayer-translations
    COMMAND Qt${QT_VERSION_MAJOR}::lupdate ${CMAKE_CURRENT_SOURCE_DIR} -ts ${TS_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Updating guiplayer translations"
)

add_custom_target( drumstick-guiplayer-translations ALL DEPENDS ${QM_FILES} )

if (UNIX AND NOT APPLE)
    install( FILES ${QM_FILES}
             DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/drumstick" )
endif ()

install(TARGETS drumstick-guiplayer
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(FILES drumstick-guiplayer.desktop
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications"
        RENAME net.sourceforge.drumstick-guiplayer.desktop)

install(FILES drumstick-guiplayer.metainfo.xml
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
        RENAME net.sourceforge.drumstick-guiplayer.metainfo.xml)

=== debian/changelog ===
libdrumstick (2.7.2-1) unstable; urgency=medium

  * New upstream version 2.7.2
  * Build with sonivox (Closes: #1017960)

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 02 Oct 2022 22:47:25 +0200

=== debian/control ===
Source: libdrumstick
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Arnout Engelen <arnouten@bzzt.net>,
 Ross Gammon <rosco2@ubuntu.com>,
 Dennis Braun <d_braun@kabelmail.de>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 docbook-xml,
 docbook-xsl,
 doxygen,
 graphviz,
 libasound2-dev,
 libfluidsynth-dev (>= 1.1.1),
 libpulse-dev,
 libqt5svg5-dev,
 libsonivox-dev,
 qtbase5-dev,
 qttools5-dev,
 libx11-dev,
 pkg-config,
 xsltproc
Standards-Version: 4.6.1
Homepage: http://drumstick.sourceforge.net/
Vcs-Git: https://salsa.debian.org/multimedia-team/libdrumstick.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libdrumstick
Rules-Requires-Root: no

Package: libdrumstick-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdrumstick-alsa2 (= ${binary:Version}),
 libdrumstick-file2 (= ${binary:Version}),
 libdrumstick-rt-backends (= ${binary:Version}),
 libdrumstick-rt2 (= ${binary:Version}),
 libdrumstick-widgets2 (= ${binary:Version}),
 ${misc:Depends}
Description: Qt5/C++ wrapper for ALSA Sequencer (development files)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package provides the development files.

Package: libdrumstick-alsa2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt5/C++ wrapper for ALSA Sequencer (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package provides the shared library.

Package: libdrumstick-file2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: File format support library for drumstick (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the shared library for support of MIDI, Cakewalk and
 RIFF MIDI file formats.

Package: libdrumstick-plugins
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Realtime MIDI I/O with pluggable backends (Qt designer plugins)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the libdrumstick Qt designer plugins.

Package: libdrumstick-rt2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 libdrumstick-rt-backends (= ${binary:Version}),
 rtkit
Description: Realtime MIDI I/O with pluggable backends (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the shared library for realtime MIDI I/O with plugin
 support.

Package: libdrumstick-rt-backends
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Realtime MIDI I/O backends
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the backends for realtime MIDI I/O.

Package: libdrumstick-widgets2
Architecture: any
Multi-Arch: same
Depends:
 drumstick-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt5/C++ wrapper for ALSA Sequencer (widgets)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the shared drumstick widgets library.

Package: drumstick-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: Qt5/C++ wrapper for ALSA Sequencer (data files)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package provides data files for drumstick-tools and libdrumstick-widgets2.

Package: drumstick-tools
Section: sound
Architecture: any
Depends:
 drumstick-data (= ${source:Version}),
 libdrumstick-plugins (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt5/C++ wrapper for ALSA Sequencer (utilities)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package provides utilities shipped with the library:
  - drumstick-drumgrid: Simple Qt drum sequencer.
  - drumstick-dumpmid: Write ALSA MIDI events to STDOUT.
  - drumstick-dumprmi: Write MIDI events from a RIFF MIDI file to STDOUT.
  - drumstick-dumpsmf: Write MIDI events from a MIDI file to STDOUT.
  - drumstick-dumpwrk: Write MIDI events from a Cakewalk WRK file to STDOUT.
  - drumstick-guiplayer: Simple Qt MIDI file player.
  - drumstick-metronome: Headless MIDI metronome.
  - drumstick-playsmf: Headless MIDI file player.
  - drumstick-sysinfo: Display information about ALSA MIDI.
  - drumstick-vpiano: Virtual Piano Keyboard GUI application.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@ -Scmake

override_dh_auto_test:
	if -f /dev/snd/seq ; then dh_auto_test ; fi
